;Release 14 compliant
(vl-load-com)
(command "audit" "y")
(defun R14_commands ()
  (if (wcmatch (ver) "AutoLISP Release 14*,LispEx*")
    (setq layer_command "-layer")
    (setq layer_command "layer")
  )
  (if (wcmatch (ver) "AutoLISP Release 14*,LispEx*")
    (setq linetype_command "-linetype")
    (setq linetype_command "linetype")
  )
)

(defun SPEEDO ( counter total string / perc)
 (if (/= counter 0)
  (progn(setq perc (itoa(fix(* 100.0(/(float counter)(float total))))))
        (princ (strcat string perc "%")))
 )
)

(defun UPDATE (/ bn bd c n fn BAD_BLOCKS)
	(command "regenauto" "off")
	(setq bd (tblnext "BLOCK" 1))
	(setq bn 0)
	(while bd
		(setq bd (tblnext "BLOCK"))
		(setq bn (1+ bn))
	)
	(setq c 1)
	(setq bd (tblnext "BLOCK" 1))
	(while bd
		(SPEEDO c bn "\rUpdating blocks....")
		(setq n (cdr(assoc 2 bd)))                                
		(setq fn (findfile (strcat n ".dwg")))
		(if fn
			(progn
				(setq fn (strcat n "=" fn))
				(if (< (strlen fn) 50)
					(progn
						(command "insert" fn "0,0" "" "" "")
						(entdel(entlast))
					)
				)
			)
			(if (NOT(wcmatch n "[*]*,_*,X*"))(setq BAD_BLOCKS (cons n BAD_BLOCKS)))      
		)
		(setq bd (tblnext "BLOCK"))
		(setq fn nil)
		(setq c (1+ c))
	)
	(if BAD_BLOCKS
		(progn
			(prompt "\n\nThe following blocks could not be updated from the Hard Drive search path:\n")
			(foreach b BAD_BLOCKS
				(prompt (strcat "\n " b))
			)
		)
	)
)

(defun READ_WEIGHT ( / wf fd part kg w_list w)
 (setq wf (getfiled "Confirm Weight Template File" "F:/Lisp/" "txt" 8))
 (setq wf (findfile wf))
 (if (NOT wf)(exit))
 (setq fd (open wf "r"))
 (setq part (read-line fd))
 (setq kg (read-line fd))
 (while kg
  (setq kg (atof kg))
  (setq w (cons part kg))
  (setq w_list (cons w w_list))
  (read-line fd)
  (setq part (read-line fd))
  (setq kg (read-line fd))
 )
 (setq w_list w_list)
)

(defun PATTERN_LIST (A_LIST)
 (mapcar '(lambda (x)
  (if (wcmatch (car x) "FASCIA IP ?#*")
      (cons (strcat (substr (car x) 1 18) "*") (cdr x))
     (if (wcmatch (car x) "FASCIA AP ?#*")
          (cons (strcat (substr (car x) 1 18) "*") (cdr x))
          (if (wcmatch (car x) "PANEL R ?#*")
               (cons (strcat (substr (car x) 1 17) "*") (cdr x))
              (if (wcmatch (car x) "PANEL WT*")
                  (cons (strcat (substr (car x) 1 16) "*") (cdr x))
                  (if (wcmatch (car x) "PANEL WB*")
                      (cons (strcat (substr (car x) 1 16) "*") (cdr x))
                      (if (wcmatch (car x) "PANEL #*")
                          (cons (strcat (substr (car x) 1 14) "*") (cdr x))                     
                          (if (wcmatch (car x) "EU ?#*")
                              (cons (strcat (substr (car x) 1 7) "*") (cdr x))
                              (cons (strcat (car x) "*") (cdr x))
  )   )   )   )   )   )  )
 ) A_LIST)
)

(defun READ_TXT (FILE_NAME / kg fn fd l n yn)
 (setq txt_list nil part_list nil weight_list nil)
 (setq fn (findfile FILE_NAME))
 (setq fd (open fn "r"))
 (setq l (read-line fd))
 (while l  
  (setq txt_list (cons l txt_list))
  (setq l (cons l 0))
  (if (NOT(member l part_list))
      (setq part_list (cons l part_list))
  )
  (setq l (read-line fd))
 )
 (close fd)
 (foreach x txt_list
  (progn
   (setq l (assoc x part_list))
   (setq n (1+ (cdr l)))
   (setq l (car l))
   (setq l (cons l n ))
   (setq part_list (subst l (assoc x part_list) part_list))
  )
 )
 (setq yn (strcase(getstring "\nInclude Weight analysis?<Y>: ")))
 (if (OR(wcmatch yn "Y*")(= yn ""))
     (WEIGHT)
     (progn
      (print part_list)
      (setq part_list (mapcar '(lambda (x)
                                (strcat      (substr (car x) 1 (- 40 (strlen (itoa (cdr x)))) )
                                        "\t" (itoa   (cdr x))
                                )
                               )
             part_list)
      )
      (setq part_list (ACAD_STRLSORT part_list))
      (textscr)
      (prompt "\n\n\t\t\tPart                               Qty")
      (prompt "\n\t\t\t--------------------------------------\n")
      (foreach x part_list (prompt (strcat "\n\t\t\t"  x)))
      (print)
     )
 )
)

(defun WEIGHT ( / weight_list match temp total_weight pr)
 (setq weight_list (READ_WEIGHT))
 (setq weight_list (PATTERN_LIST weight_list))
 (setq part_list (mapcar '(lambda (x)
                           (foreach y weight_list
                             (if (wcmatch (car x)(car y))
                                 (setq match (list (car x)(cdr x)(* (cdr x)(cdr y))))
                             )
                           )
                           (if (NOT match)
                               (progn
                                (setq pr (strcat "\n"(substr (car x) 1 40) "No match in Weight Template."))
                                (setq match (list (car x)(cdr x) 0.0))
                               )
                           )
                           (if pr (prompt pr))
                           (setq pr nil)
                           (setq temp match)
                           (setq match nil)
                           (setq temp temp)
                          )
        part_list)
 )
 (setq total_weight 0.0)
 (foreach x part_list
   (setq total_weight (+ total_weight (caddr x)))
 )
 (setq total_weight (strcat "TOTAL WEIGHT = " (rtos total_weight 2 2) " Kg"))

 (setq part_list (mapcar '(lambda (x)
                           (strcat      (substr (car x) 1 (- 30 (strlen (itoa (cadr x)))))
                                   "\t" (itoa   (cadr x))
                                   "\t" (rtos   (caddr x) 2 2)
                           )
                          )
        part_list)
 )
 (setq part_list (ACAD_STRLSORT part_list))
 (textscr)
 (prompt "\n\n\t\t\tPart                               Qty     Weight")
 (prompt "\n\t\t\t-------------------------------------------------\n")
 (foreach x part_list (prompt (strcat "\n\t\t\t" x)))
 (prompt  (strcat "\n\n\t\t\t" total_weight))
 (prompt "\n\t\t\t-----------------------")
 (print)

 (setq yn (strcase(getstring "\nPrint Results to File?<Y>: ")))
 (if (OR(wcmatch yn "Y*")(= yn ""))
     (PRINT_TO_FILE part_list)
 )
)

(defun PRINT_TO_FILE (A_LIST / rf c)
 (setq rf (strcat (substr df 1 (- (strlen df) 4)) "_report"))
 (setq fn (getfiled "Confirm Report File" rf "txt" 1))
 (setq fd (open fn "w"))
 (setq c 0)
 (princ  "Part                             Qty     Weight" fd)
 (princ  "\n-----------------------------------------------" fd)
 (princ "\n" fd)
 (repeat (length A_LIST)
  (princ (strcat "\n" (nth c A_LIST)) fd)
  (setq c (1+ c))
 )
 (princ (strcat "\n\n" total_weight) fd)
 (close fd)
) 


(defun C:Extract (/ yn g tf df dn pn layer_command linetype_command txt_list part_list)
 (R14_commands)
 (setvar "filedia" 0)
 (setvar "cmdecho" 0)
 (setvar "osmode" 0)
 (command "undo" "mark")
 (command layer_command "u" "*" "")
 (setq yn (strcase(getstring "\nUpdate all blocks from hard drive?<N>: ")))
 (if (wcmatch yn "Y*")
     (UPDATE)
 )
 (setq tf (getfiled "Confirm Extraction Template File" "F:/Lisp/" "txt" 8))
 (if (NOT tf)(exit))

 (setq dn (getvar "dwgname"))
 (setq dn (substr dn 1 (- (strlen dn) 4)))
 (setq pn (getvar "dwgprefix"))
 (setq df (strcat pn dn))
 (setq df (getfiled "Confirm Attribute Destination File" df "txt" 1))
 (if (NOT df)(exit))

 (prompt "\nSelect attribute blocks:")
 (setq g (ssget))
 (if g 
  (progn
   (command "attext" "e" g "" "s" tf df)
   (setq yn (strcase(getstring "\nPrint Results to Screen?<Y>: ")))
   (if (OR(wcmatch yn "Y*")(= yn ""))
       (READ_TXT df)
   )
   ;(setq yn (strcase(getstring "Start MS Word?<Y>: ")))
   ;(if (OR(wcmatch yn "Y*")(= yn ""))
   ;    (startapp "C:/Program Files/Microsoft Office/Office/WINWORD.EXE" df)
   ;)
   ;(setq yn (strcase(getstring "Start Bill of Materials package?<N>: ")))
   ;(if (OR(wcmatch yn "N*")(= yn ""))
   ;   (startapp "C:/Bomp/BillOfMaterials.exe")
   ;)
  )
 )
 (setvar "Filedia" 1)
 (setvar "cmdecho" 1)
 (command "-layer" "lock" "v-structure, -v-structure" "")
 (princ)
)

(PROMPT "\nUse EXTRACT to extract attributes into a TXT file.")(princ)













